Bug 462897 - [RHEL4.6]gdb non-static variable missing DW_AT_location
[RHEL4.6]gdb non-static variable missing DW_AT_location
Product: Red Hat Enterprise Linux 4
Classification: Red Hat
Component: gdb (Show other bugs)
All Linux
low Severity low
: rc
: ---
Assigned To: Jan Kratochvil
Depends On:
Blocks: 445912
  Show dependency treegraph
Reported: 2008-09-19 11:16 EDT by Alan Matsuoka
Modified: 2010-10-23 00:39 EDT (History)
2 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Last Closed: 2009-01-20 16:10:38 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---

Attachments (Terms of Use)

  None (edit)
Description Alan Matsuoka 2008-09-19 11:16:09 EDT
Description of problem:
I thought that we had a case open on this already but I don't see it.

Date problem reported: 1-15-08

LLNL basically has a gcc issue that apparently has stalled out on the gcc bugzilla lists. Both bugs are related to local (static and non-static) variables in C++ constructor.  At this point we aren't sure if the two are actually one in the same or separate issues.  The issue (according to the output sent in by Ben) is still present even in the latest versions of the gcc compiler in RHEL5.1.

This has also been cloned for RHEL4.6 in IT 158679

What's needed from SEG / Engineering: The customer has asked for our help in getting these issues resolved on the gcc lists so they can be ported to the RHEL releases in a future fix.

Source file and readelf output from customer is attached.


Date: Tue, 15 Jan 2008 13:54:20 -0500
From: Seppo Sahrakorpi <seppo@totalviewtech.com>
Organization: Totalview Technologies
User-Agent: Thunderbird (X11/20070728)
MIME-Version: 1.0
To: Ben Woodard <bwoodard@llnl.gov>
Cc: Matt Wolfe <mwolfe@llnl.gov>,
       Nikolay Piskun <nikolay.piskun@totalviewtech.com>,
Subject: Update/help needed: Local variables not visible in C++ constructor
Content-Type: text/plain; charset=ISO-8859-1; format=flowed
Content-Transfer-Encoding: 7bit

Hi Ben,

I would like to bring to your attention / update you on two bugs related
to local (static and non-static) variables in C++ constructor.

The short summary of the bugs is as follows: "In gcc 3.2.3 (and more
recent versions) the DWARF information created by gcc does not create
DW_AT_location attribute for (1) local static variables and (2) local
(non-static) static variables inside a C++ constructor."

We have reported these bugs to gcc-bugzilla, where they are not moving
very quickly. We were thinking that perhaps you could help in getting
these bugs fixed.

The local static variable problem is gcc-bug #33044, and the local
(non-static) variable problem is gcc-bug #27574.

The bug number #27574 is being reviewed by a new person right now.

The ("static") report #33044, seems to have stuck in the system, it
would be great if you could help finding someone who could give this a
look and move it forward.


Seppo Sahrakorpi
Partner Technologies Engineer
TotalView Technologies, 24 Prime Parkway, Natick, MA 01760

Version-Release number of selected component (if applicable):

How reproducible:

Steps to Reproduce:
1. see http://gcc.gnu.org/bugzilla/show_bug.cgi?id=33044
Actual results:
can't display var

Expected results:

variable value should be displayed.
Additional info:
attached test files.
Comment 1 Issue Tracker 2008-09-19 13:50:27 EDT
Just to clarify any confusion here. see
See IT 146253 and 

This event sent from IssueTracker by alanm 
 issue 158679
Comment 2 RHEL Product and Program Management 2008-10-31 12:46:16 EDT
This request was evaluated by Red Hat Product Management for
inclusion, but this component is not scheduled to be updated in
the current Red Hat Enterprise Linux release. If you would like
this request to be reviewed for the next minor release, ask your
support representative to set the next rhel-x.y flag to "?".
Comment 5 RHEL Product and Program Management 2009-01-20 16:10:38 EST
Development Management has reviewed and declined this request.  You may appeal
this decision by reopening this request.

Note You need to log in before you can comment on or make changes to this bug.